---
title: IDBIndex.openKeyCursor()
slug: Web/API/IDBIndex/openKeyCursor
tags:
  - API
  - Database
  - IDBIndex
  - IndexedDB
  - Method
  - Reference
  - Storage
  - openKeyCursor
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>openKeyCursor()</code></strong> method of the {{domxref("IDBIndex")}} interface returns an {{domxref("IDBRequest")}} object, and, in a separate thread, creates a cursor over the specified key range, as arranged by this index.</p>
</div>

<p>The method sets the position of the cursor to the appropriate key, based on the specified direction.</p>

<ul>
 <li>If the key range is not specified or is null, then the range includes all the keys.</li>
 <li>A <a href="/en/IndexedDB/IDBSuccessEvent" title="en/IndexedDB/IDBSuccessEvent">success event</a> is always fired on the result object.
  <ul>
   <li>If at least one key matches the key range, then the <code>result</code> property of the event is set to the new {{domxref("IDBCursor")}} object; the <code>key</code> property of the cursor object is set to the found key and the <code>primaryKey</code> property is set to the corresponding primary key of the found record.</li>
   <li>If no keys match the key range, then the <code>result</code> property of the event is set to <code>null</code>. </li>
  </ul>
 </li>
</ul>

<div class="note">
<p><span><strong>Note: </strong>Cursors returned by <code>openKeyCursor()</code> do not make the referenced value available </span>as <a href="/en-US/docs/Web/API/IDBIndex/openCursor"><code>IDBIndex.openCursor</code></a> does<span>. This makes obtaining a list of keys much more efficient.</span></p>
</div>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox" style="font-size: 14px;">var <em>request</em> = <em>myIndex</em>.openKeyCursor();
var <em>request</em> = <em>myIndex</em>.openKeyCursor(<em>range);</em>
var <em>request</em> = <em>myIndex</em>.openKeyCursor(<em>range</em>, <em>direction</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>range {{optional_inline}}</dt>
 <dd>A key or {{domxref("IDBKeyRange")}} to use as the cursor's range. If nothing is passed, this will default to a key range that selects all the records in this object store.</dd>
 <dt>direction {{optional_inline}}</dt>
 <dd>The cursor's <a href="/en/IndexedDB/IDBCursor#Constants" title="en/indexedDB#gloss direction">direction</a>. See <a href="/en/IndexedDB/IDBCursor#Constants" title="en/IndexedDB/IDBCursor#Constants">IDBCursor Constants</a> for possible values.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This {{domxref("IDBIndex")}}'s transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>TypeError</code></td>
   <td>The value for the direction parameter is invalid.</td>
  </tr>
  <tr>
   <td><code>DataError</code></td>
   <td>
    <p>The key or key range provided contains an invalid key.</p>
   </td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("IDBIndex")}} has been deleted or removed.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<div class="note"></div>

<p>In the following example we open a transaction and an object store, then get the index <code>lName</code> from a simple contacts database. We then open a key cursor on the index using <code>openKeyCursor()</code> — this works the same as opening a cursor directly on an <code>ObjectStore</code> using {{domxref("IDBObjectStore.openKeyCursor")}} except that the returned records are sorted based on the index, not the primary key.</p>

<p>Finally, we iterate through each record in the index, and insert the last name and the corresponding primary key of the referenced record into an HTML table.</p>

<pre class="brush: js">function displayDataByIndex() {
  tableEntry.innerHTML = '';
  var transaction = db.transaction(['contactsList'], 'readonly');
  var objectStore = transaction.objectStore('contactsList');

  var myIndex = objectStore.index('lName');

  myIndex.openKeyCursor().onsuccess = function(event) {
    var cursor = event.target.result;
    if(cursor) {
      var tableRow = document.createElement('tr');
      tableRow.innerHTML =   '&lt;td&gt;' + cursor.key + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.primaryKey + '&lt;/td&gt;';
      tableEntry.appendChild(tableRow);

      cursor.continue();
    } else {
      console.log('All last names displayed.');
    }
  };
};</pre>

<h2 id="Specification"><span style="font-size: 2.14285714285714rem;">Specification</span></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbindex-openkeycursor', 'openKeyCursor()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbindex-openkeycursor", "openKeyCursor()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBIndex.openKeyCursor")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
